/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 3/22/2006; 11:20:33 PM

#include "All.h"

//Move Player.c
static inline void steerPlayer(Player *);
static inline void acceleratePlayer(Player *);
//waypoints.c
void checkWaypoint(Player *, unsigned char [][128]);


void getKeyInput() {
	unsigned char k = 0;
	k |= (_keytest(RR_LEFT)?																					FLAG_KEY_STEER_LEFT:0);
	k |= (_keytest(RR_RIGHT)?																					FLAG_KEY_STEER_RIGHT:0);	
	k |= ((_keytest(RR_DIAMOND) || _keytest(RR_Q) || _keytest(RR_F1))?												FLAG_KEY_DRIFT:0);	
	k |= ((_keytest(RR_UP) || _keytest(RR_2ND) || _keytest(RR_HAND))?	FLAG_KEY_ACCELERATE:0);	
	k |= ((_keytest(RR_DOWN))?											FLAG_KEY_BRAKE:0);	
	allocatedMem->p.keyPressed = k;
}


/*
	Steer, accelerate and change the coordinates of the Player
*/
void movePlayer(Player *p) {
	steerPlayer(p);
	acceleratePlayer(p);
	p->previousX = p->x;
	p->previousY = p->y;
	p->x-=p->vx>>7;
	p->y-=p->vy>>7;
	checkWaypoint(p,allocatedMem->waypointArray);
	p->currentFPL++;
}


/*
	Change the direction the player is going
*/
static inline void steerPlayer(Player *p) {
	
	if (p->keyPressed&FLAG_KEY_STEER_LEFT) 	p->stearingAngle+=4*(p->stearingAngle<(2<<2));
	if (p->keyPressed&FLAG_KEY_STEER_RIGHT)	p->stearingAngle-=4*(p->stearingAngle>-(2<<2));

	p->stearingAngle+=(p->stearingAngle<0?2:(p->stearingAngle>0?-2:0));
	//p->orientation=(p->stearingAngle<0?DIR_RIGHT:(p->stearingAngle>0?DIR_LEFT:DIR_STRAIGHT));

	if (abs(p->speed) < 10)
	p->shiftedAngle+=(p->stearingAngle*p->speed)/12;
	else	
	p->shiftedAngle+=(p->speed>0?(p->stearingAngle):-(p->stearingAngle));
	
	/*
	if (_keytest(RR_F2)) {
		p->shiftedAngle+=10;
	}
	if (_keytest(RR_F3)) {
		p->shiftedAngle-=10;
	}
	*/
						
	while (p->shiftedAngle > 127<<2)
	p->shiftedAngle-=127<<2;
	while (p->shiftedAngle < 0)
	p->shiftedAngle+=127<<2;

	p->angle=p->shiftedAngle>>2;	
}




/*
	Change the vx and vy of the player
*/
static inline void acceleratePlayer(Player *p) {
	
	if (!(p->keyPressed&FLAG_KEY_DRIFT)) {//<= drift
	p->shiftedSpeed-=(p->shiftedSpeed>0?(1<<SHIFT_SPEED):(p->shiftedSpeed<0?-(1<<SHIFT_SPEED):0));
	
	if (p->keyPressed&FLAG_KEY_ACCELERATE) {
		p->shiftedSpeed+=(7<<(SHIFT_SPEED-1));
	}
	else {
		if (p->keyPressed&FLAG_KEY_BRAKE) {
			if (p->shiftedSpeed>-(20<<SHIFT_SPEED))
			p->shiftedSpeed-=(3<<SHIFT_SPEED);
		}
		else {
			
		}
	}
	p->shiftedSpeed -= p->shiftedSpeed>>5;
	p->speed = p->shiftedSpeed>>SHIFT_SPEED;
	

	long dVx=((sinTable_512[p->angle]*p->shiftedSpeed)>>SHIFT_SPEED)-p->vx;
	long dVy=((cosTable_512[p->angle]*p->shiftedSpeed)>>SHIFT_SPEED)-p->vy;
	p->vx += dVx>>3;
	p->vy += dVy>>3;
	
	if (abs(p->vx)<4 && abs(p->vy)<4) {//this eliminates small errors that occurs at very very low speed
		p->vx=0;
		p->vy=0;
	}
	}
	else
	{
		
		
	}
		
}